/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(WEBGPU)

#include "GPUUncapturedErrorEvent.h"
#include "JSDOMConvertDictionary.h"
#include "JSDOMWrapper.h"
#include "JSEvent.h"

namespace WebCore {

class JSGPUUncapturedErrorEvent : public JSEvent {
public:
    using Base = JSEvent;
    using DOMWrapped = GPUUncapturedErrorEvent;
    static JSGPUUncapturedErrorEvent* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<GPUUncapturedErrorEvent>&& impl)
    {
        JSGPUUncapturedErrorEvent* ptr = new (NotNull, JSC::allocateCell<JSGPUUncapturedErrorEvent>(globalObject->vm().heap)) JSGPUUncapturedErrorEvent(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::JSType(JSEventType), StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    GPUUncapturedErrorEvent& wrapped() const
    {
        return static_cast<GPUUncapturedErrorEvent&>(Base::wrapped());
    }
protected:
    JSGPUUncapturedErrorEvent(JSC::Structure*, JSDOMGlobalObject&, Ref<GPUUncapturedErrorEvent>&&);

    void finishCreation(JSC::VM&);
};

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, GPUUncapturedErrorEvent&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, GPUUncapturedErrorEvent* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<GPUUncapturedErrorEvent>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<GPUUncapturedErrorEvent>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<GPUUncapturedErrorEvent> {
    using WrapperClass = JSGPUUncapturedErrorEvent;
    using ToWrappedReturnType = GPUUncapturedErrorEvent*;
};
#if ENABLE(WEBGPU)

template<> GPUUncapturedErrorEvent::Init convertDictionary<GPUUncapturedErrorEvent::Init>(JSC::JSGlobalObject&, JSC::JSValue);

#endif


} // namespace WebCore

#endif // ENABLE(WEBGPU)
