/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(PAYMENT_REQUEST)

#include "JSPaymentDetailsModifier.h"

#include "JSDOMConvertObject.h"
#include "JSDOMConvertSequences.h"
#include "JSDOMConvertStrings.h"
#include "JSPaymentItem.h"
#include <JavaScriptCore/JSArray.h>
#include <JavaScriptCore/JSCInlines.h>


namespace WebCore {
using namespace JSC;

#if ENABLE(PAYMENT_REQUEST)

template<> PaymentDetailsModifier convertDictionary<PaymentDetailsModifier>(JSGlobalObject& lexicalGlobalObject, JSValue value)
{
    VM& vm = JSC::getVM(&lexicalGlobalObject);
    auto throwScope = DECLARE_THROW_SCOPE(vm);
    bool isNullOrUndefined = value.isUndefinedOrNull();
    auto* object = isNullOrUndefined ? nullptr : value.getObject();
    if (UNLIKELY(!isNullOrUndefined && !object)) {
        throwTypeError(&lexicalGlobalObject, throwScope);
        return { };
    }
    PaymentDetailsModifier result;
    JSValue additionalDisplayItemsValue;
    if (isNullOrUndefined)
        additionalDisplayItemsValue = jsUndefined();
    else {
        additionalDisplayItemsValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "additionalDisplayItems"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!additionalDisplayItemsValue.isUndefined()) {
        result.additionalDisplayItems = convert<IDLSequence<IDLDictionary<PaymentItem>>>(lexicalGlobalObject, additionalDisplayItemsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue dataValue;
    if (isNullOrUndefined)
        dataValue = jsUndefined();
    else {
        dataValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "data"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!dataValue.isUndefined()) {
        result.data = convert<IDLObject>(lexicalGlobalObject, dataValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    JSValue supportedMethodsValue;
    if (isNullOrUndefined)
        supportedMethodsValue = jsUndefined();
    else {
        supportedMethodsValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "supportedMethods"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!supportedMethodsValue.isUndefined()) {
        result.supportedMethods = convert<IDLDOMString>(lexicalGlobalObject, supportedMethodsValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    } else {
        throwRequiredMemberTypeError(lexicalGlobalObject, throwScope, "supportedMethods", "PaymentDetailsModifier", "DOMString");
        return { };
    }
    JSValue totalValue;
    if (isNullOrUndefined)
        totalValue = jsUndefined();
    else {
        totalValue = object->get(&lexicalGlobalObject, Identifier::fromString(vm, "total"));
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    if (!totalValue.isUndefined()) {
        result.total = convert<IDLDictionary<PaymentItem>>(lexicalGlobalObject, totalValue);
        RETURN_IF_EXCEPTION(throwScope, { });
    }
    return result;
}

#endif

} // namespace WebCore

#endif // ENABLE(PAYMENT_REQUEST)
