/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(CSS_TYPED_OM)

#include "JSDOMWrapper.h"
#include "JSStylePropertyMapReadOnly.h"
#include "StylePropertyMap.h"

namespace WebCore {

class JSStylePropertyMap : public JSStylePropertyMapReadOnly {
public:
    using Base = JSStylePropertyMapReadOnly;
    using DOMWrapped = StylePropertyMap;
    static JSStylePropertyMap* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<StylePropertyMap>&& impl)
    {
        JSStylePropertyMap* ptr = new (NotNull, JSC::allocateCell<JSStylePropertyMap>(globalObject->vm().heap)) JSStylePropertyMap(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    StylePropertyMap& wrapped() const
    {
        return static_cast<StylePropertyMap&>(Base::wrapped());
    }
protected:
    JSStylePropertyMap(JSC::Structure*, JSDOMGlobalObject&, Ref<StylePropertyMap>&&);

    void finishCreation(JSC::VM&);
};

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, StylePropertyMap&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, StylePropertyMap* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<StylePropertyMap>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<StylePropertyMap>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<StylePropertyMap> {
    using WrapperClass = JSStylePropertyMap;
    using ToWrappedReturnType = StylePropertyMap*;
};

} // namespace WebCore

#endif // ENABLE(CSS_TYPED_OM)
